#ifndef GAMMAMANANGERTHREAD_H
#define GAMMAMANANGERTHREAD_H
#include <QThread>
#include <QMutex>
#include <QX11Info>
#include "gamma-manager-define.h"
#include "gamma-manager-adaptor.h"
#include "gamma-manager-helper.h"
class GmThread: public QThread
{
    Q_OBJECT
public:
    GmThread(QObject *parent = nullptr);
    ~GmThread();
    void setBrightness(int brightness);
    void setTemperature(int temperature);
    OutputGammaInfoList getAllOutputGammaInfo();
protected:
    void run();
public Q_SLOTS:
    void doSetTimer();
private:
    int m_brightness;
    int m_targetTemp;
    int m_lastTemperature;
    int m_rtTemperature;
    int m_timerRunTimes;
    QTimer *m_pSetTimer;
    GmHelper *m_pGmHelper;
};

#endif // GAMMAMANANGERTHREAD_H
