#ifndef PINGPONGTEST_H
#define PINGPONGTEST_H

#include <QNetworkAccessManager>
#include <QNetworkReply>
#include <QDBusInterface>
#include <QObject>
#include <QTimer>

#include "clib-syslog.h"
#include "gamma-manager-define.h"
#include "QGSettings/qgsettings.h"
#include "gamma-manager-helper.h"

class testInfo:public QObject
{
    Q_OBJECT
public:
    testInfo(QObject *parent = nullptr){
        url = "";
        m_less100ms = 0;
        m_less1000ms = 0;
        m_less2000ms = 0;
        m_less3000ms = 0;
        m_less4000ms = 0;
        m_exceed4000ms = 0;
        testTimes = 0;
        totalTime = 0;
        avgTime = 0;
        m_miss = 0;
    }
    QString url;
    int m_less100ms;
    int m_less1000ms;
    int m_less2000ms;
    int m_less3000ms;
    int m_less4000ms;
    int m_exceed4000ms;
    int testTimes;
    qulonglong totalTime;
    double avgTime;
    int m_miss;
};

class PingPongTest: public QObject
{
    Q_OBJECT
public:
    PingPongTest(QObject *parent =nullptr);

    void setTestUrlList(QStringList urlList);
    void start();
public Q_SLOTS:
    void doNAMFinished(QNetworkReply *reply);
    void doTimerOut();
    void doNAMTimerOut();
private:
    void setBeyondTime(QString url, int time, int error = 0);
private:
    QStringList m_urlList;
    QString     m_currentUrl;
    int m_RTurl;
    QTimer      *m_pGetTimer;
    QTimer      *m_NAMTimr;
    QTime       m_connectTime;
    GmHelper                *m_pGmHelper;
    QNetworkAccessManager   *m_NAM;
    QSizeF                   m_location;
    QList<testInfo*> m_testDataList;
};

#endif // PINGPONGTEST_H
